.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm

COMMENT @ ca. 260 clocks for overhead
6635     clocks for HeapAlloc, 00010000h bytes, 103 per kByte
5926     clocks for HeapAlloc, 00008000h bytes, 185 per kByte
5200     clocks for HeapAlloc, 00004000h bytes, 325 per kByte
4329     clocks for HeapAlloc, 00002000h bytes, 541 per kByte
3384     clocks for HeapAlloc, 00001000h bytes, 846 per kByte
2309     clocks for HeapAlloc, 00000800h bytes, 1154 per kByte
1282     clocks for HeapAlloc, 00000400h bytes, 1282 per kByte
817      clocks for HeapAlloc, 00000200h bytes, 1634 per kByte
557      clocks for HeapAlloc, 00000100h bytes, 2228 per kByte
401      clocks for HeapAlloc, 00000080h bytes, 3208 per kByte

3285     clocks for VirtualAlloc, 00010000h bytes, 51 per kByte
5586     clocks for VirtualAlloc, 00008000h bytes, 174 per kByte
7846     clocks for VirtualAlloc, 00004000h bytes, 490 per kByte
10150    clocks for VirtualAlloc, 00002000h bytes, 1268 per kByte
12409    clocks for VirtualAlloc, 00001000h bytes, 3102 per kByte
14668    clocks for VirtualAlloc, 00000800h bytes, 7334 per kByte
17007    clocks for VirtualAlloc, 00000400h bytes, 17007 per kByte
19231    clocks for VirtualAlloc, 00000200h bytes, 38462 per kByte
21507    clocks for VirtualAlloc, 00000100h bytes, 86028 per kByte
23731    clocks for VirtualAlloc, 00000080h bytes, 189848 per kByte
@

	ALLOC_BYTES	= 16*10000h
	Magic	= 20000
	M2		= 2000

if 1
	PrintIt equ <print chr$(" clocks for HeapAlloc, ")>
	; TestIt	equ	<invoke HeapAlloc, ProHeap, HEAP_GENERATE_EXCEPTIONS or HEAP_NO_SERIALIZE, ALLOC_BYTES>
	TestIt	MACRO
		invoke HeapAlloc, ProHeap, HEAP_GENERATE_EXCEPTIONS or HEAP_NO_SERIALIZE, ALLOC_BYTES
		.if eax==0
			Int 3
			mov esi, esi
		.endif
		invoke HeapReAlloc, ProHeap, HEAP_GENERATE_EXCEPTIONS or HEAP_NO_SERIALIZE, eax, ALLOC_BYTES/16
		.if eax==0
			Int 3
			mov ebx, ebx
		.endif
		endm
		
		
elseif 1
	TestIt	equ	<invoke VirtualAlloc, NULL, ALLOC_BYTES, MEM_COMMIT, PAGE_READWRITE>
	PrintIt equ <print chr$(" clocks for VirtualAlloc, ")>
else
	TestIt	equ	<invoke GlobalAlloc, NULL, ALLOC_BYTES>
	PrintIt equ <print chr$(" clocks for GlobalAlloc, ")>
endif

AlloTest MACRO
	ALLOC_BYTES	= ALLOC_BYTES/2
	LOOP_COUNT = ALLOC_BYTES/Magic+M2
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		TestIt
	counter_end
	push eax
	print str$(eax), 9
	PrintIt
	print hex$(ALLOC_BYTES), "h bytes, "
	pop eax
	mov ecx, 1024
	mul ecx
	mov ecx, ALLOC_BYTES
	div ecx
	print str$(eax), " per kByte", 13, 10
ENDM

.data?
ProHeap	dd ?

.code



Start:
	invoke GetProcessHeap
	.if eax==0
		MsgBox 0, chr$("GetProcessHeap failure"), chr$("HeapSpeed:"), MB_OK
	.else
		mov ProHeap, eax
		REPEAT 10
		  AlloTest
		  ENDM
		; getkey
	.endif
	exit

end Start
OPT_Tmp2Asm	1
Allocated	cycles	0
1000h	3470
5000h	5450
10000h	6750
20000h	8200
50000h	12000
100000h	19460

Allocated	cycles	HEAP_GENERATE_EXCEPTIONS
1000h	3520
5000h	5430
10000h	6800
20000h	8180
50000h	12600
100000h	19460

Allocated	cycles	HEAP_GENERATE_EXCEPTIONS or HEAP_NO_SERIALIZE
1000h	3380
5000h	5330
10000h	6630
20000h	7880
50000h	10500

Allocated	cycles	HEAP_GENERATE_EXCEPTIONS or HEAP_NO_SERIALIZE
1000h	7100
5000h	41000
10000h	103600
20000h	206000
50000h	512000
